/**
 * <p> A class which stores a counter value. 
 * @author jackie
 */
public class Counter {
	/**
	 * An integer counter.
	 */
	public static int i = 5;
	
	/**
	 * Maximum value of the counter.
	 */
	public static final int MAX = 10;
	
	/**
	 * Minimum value of the counter.
	 */
	public static final int MIN = 0;
	
	/**
	 * <p> Increemnt the counter by an amount of 'j'.
	 * @param j The amount to be incremented.
	 * @exception IllegalArgumentException Incrementing by 'j' resuts in a value greater than MAX. 
	 */
	public static void incrementBy (int j) {
		if(i + j > MAX) {
			throw new IllegalArgumentException("Too much to increment: " + j);
		}
		else {
			i += j;
		}
	}
	
	/**
	 * <p> Increemnt the counter by an amount of 'j'.
	 * @param j The amount to be incremented.
	 * @exception IllegalArgumentException Decrementing by 'j' resuts in a value greater than MAX 
	 */
	public static void decrementBy (int j) {
		if(i - j < MIN) {
			throw new IllegalArgumentException("Too much to decrement: " + j);
		}
		else {
			i -= j;
		}
	}
	
	/**
	 * <p> Determine if 'j' is greater than zero or not.
	 * <p> There is no precondition for this method: any input 'j' can be decided.
	 * @param j Some integer value.
	 * @return Return true if 'j' is positive; false otherwise.
	 */
	public static boolean isPositive (int j) {
		if(j > 0) {
			return true;
		}
		else {
			return false;
		}
	}
}
